#include "adc.h"
#include "intrins.h"

u16 adc_val;						//жϻȡĵֵ

#if ADC_Func == ADC_CHECK

	int BGV;		//1.19vѹֵ
	
	#define VREFH_ADDR  CHIPID7
	#define VREFL_ADDR  CHIPID8
	
	//========================================================================
	// : ADC_Init
	// : ADCʼ
	// ڲ: 
	// : 
	// ǰ汾: VER1.0
	// ޸: 2023
	// ǰ:
	// ע: 
	//========================================================================
	void ADC_Init( void )
	{
		P1M0 = 0x00; 					//P10Ϊ
		P1M1 = 0x01; 

		ADCTIM = 0X3F;					//
		ADCCFG = 0X2F;					//Ҷ룬ʱѡλSYSCLK/2/16
		ADC_POWER = 1;					//adcԴ
	}


	//========================================================================
	// : ADC_Read
	// : ȡָͨadcѹ
	// ڲ: @no:ͨ0-15
	// : ǰ12λadcֵ
	// ǰ汾: VER1.0
	// ޸: 2023
	// ǰ:
	// ע: 
	//========================================================================
	u16  ADC_Read( u8 no )
	{
		u16 adcval;								//adcֵ
		ADC_CONTR &= 0xf0;						//ͨ
		ADC_CONTR |= no;						//ѡͨ
		ADC_START = 1;							//ADCת
		_nop_();								//ղָ
		_nop_();			
		while(!ADC_FLAG);						//ȴADCת
		ADC_FLAG = 0;		
		adcval = (ADC_RES << 8)  + ADC_RESL;	//adcֵ
		adc_val = adcval;
		return adcval;
	}

	//========================================================================
	// : 
	// : 
	// ڲ: @
	// : 0-5000 Ӧ0-5V
	// ǰ汾: VER1.0
	// ޸: 2023
	// ǰ:
	// ע: 
	//========================================================================
	u16 ADC_VrefCal(void)
	{
		u8 i;
		int res;
		int vcc;
		
		BGV = ((VREFH_ADDR <<8) + VREFL_ADDR);		//ȡڲ1.19Vĵѹֵ
		
		ADC_Init();									//ʼADC
		ADC_Read(15);
		ADC_Read(15);
		ADC_Read(15);
		ADC_Read(15);
		for( i=0;i<8;i++ )
		{
			res += ADC_Read(15);
		}
		res >>= 3;
		vcc = (int)(4096L * BGV /res);
		return vcc;
	}
	
	//adcѯض
#elif ADC_Func == ADC_Isr
	
	//========================================================================
	// : ADC_Init
	// : жϵadcʼ
	// ڲ: 
	// : 
	// ǰ汾: VER1.0
	// ޸: 2023
	// ǰ:
	// ע: 
	//========================================================================
	void ADC_Init( void )
	{
		P1M0 = 0x00; 					//P10Ϊ
		P1M1 = 0x01; 

		ADCTIM = 0X3F;					//
		ADCCFG = 0X2F;					//Ҷ룬ʱѡλSYSCLK/2/16
		ADC_POWER = 1;					//adcԴ
		EADC = 1;						//ж
		ADC_START = 1;					//ADCת
	}

	void ADC_iSR() interrupt 5
	{
		ADC_FLAG = 0;							//նȡ־λ
		adc_val = (ADC_RES << 8)  + ADC_RESL;	//ȡadcֵ
		ADC_START = 1;							//ADCת
	}

	//adcжϵض
#else
	
#endif
	
	
//========================================================================
// : ADC_CAL_Voltage
// : adcֵɵԴѹ
// ڲ: @numadcֵ  0-4095
// : Դѹ λmv
// ǰ汾: VER1.0
// ޸: 2023
// ǰ:
// ע: 
//========================================================================
u16 ADC_CAL_Voltage(u16 num)
{
	return num*2.5*1000 /4096;

}


//========================================================================
// : 
// : 
// ڲ: @
// : һť 1-16  0ûа
// ǰ汾: VER1.0
// ޸: 2023
// ǰ:
// ע: 
//========================================================================

#define ADC_OFFEST 64   //adc

u8 ADC_KeyRead( u16 adc )
{
	u8 i;
	u16 adc_cmp;					//ǰadcıȽ256*1 256*2
	static u8 key_last = 0;			//һε״̬
	static u16 key_downtime;		//ʱ
	
	//ťûа£һťadc256
	if( adc < (256 -ADC_OFFEST)  )
	{
		key_downtime = 0;			//zûа£0
		key_last = 0;				//һΰ״̬0
	}
	adc_cmp = 256;					//һadcȽϵֵ
	for( i=1;i<=16;i++ )
	{
		if(( adc>=( adc_cmp-ADC_OFFEST ) )&&( adc<=( adc_cmp+ADC_OFFEST ) ))		// adccmp - 64 =< adc =< adccmp + 64 
		{
			//return i;
			break;
		}
		else
			adc_cmp+=256;															//ǰadcȽֵ+256
	}
	//break˳forѭִ֮
	if( i>16 )
	{
		key_downtime = 0;			//zûа£0
		key_last = 0;				//һΰ״̬0		
	}
	else
	{
		if( key_last == i )			//źһһ
		{
			key_downtime ++;		//ʱһ
			if( key_downtime==3 )	//10ms*3һ
			{
				return i;
			}
			else if( key_downtime==300 )//10ms*300һ
			{
				key_downtime = 290;
				return i+0x80;		//0000 0000
			}
			else 
				return 0;
		}
		else
		{
			key_downtime = 0;			//һΰ״̬0
			key_last = i;				//ΰµİ֮ǰһ汾ε
		}
	}
	
	return 0;
}

/*
 ΰ  һ״̬   
	0          0        0
    1          1        0
    1          1        1
    1          1        2
    1          1        3		//δ
    1          1        4		//
    0          0        0
    2          2        0
    2          2        1
    2          2        2

*/

	//ոհ´һ 3봥һ 3ÿ0.1Ŵһ	//±+1 ɿ0