#include "spi.h"

#if SPI_MODE == 0
	void SPI_Init(void)				//ʼ
	{
		CS 	  = 1;					//ѡи
		MISO  = 1;					//	
		WP	  = 1;			
		MOSI  = 1;	
		SCLK  = 0;					//spiģʽ0sclkʼΪ͵ƽ	
	}


	void SPI_WriteByte(u8 dat)		//дһֽ
	{
		u8 i;
		for( i=0;i<8;i++ )
		{
			if( dat & 0x80 )
				MOSI = 1;
			else
				MOSI = 0;
			SCLK = 1;				//½
			SCLK = 0;
			dat <<=1;
		}
	}


	u8 SPI_ReadByte(void)			//ȡһֽ
	{
		u8 i;
		u8 dat=0;
		
		for( i=0;i<8;i++ )
		{
			dat<<=1;
			
			SCLK = 1;				
			if( MISO )				//ӻݵ
				dat |= 1;
	//		else
	//			dat |= 0;
			SCLK = 0;
		}
		
		return dat;
	}

#elif SPI_MODE == 1
	void SPI_Init(void)				//ʼ
	{
		P_SW1 &= 0XF3;		//1111 0011		ѡ
		P_SW1 |= 0X04;		//0000 0100
		
		SPCTL = 0X90;		//ģʽ
		SPCTL |= 0X40;
		
		SCLK = 0;			//yųʼ
		
		SPIF = 1;			//ձ־λ
		WCOL = 1;
	}


	void SPI_WriteByte(u8 dat)		//дһֽ
	{
		SPDAT = dat;
		while(SPIF == 0);
		SPIF = 1;
		WCOL = 1;
	}


	u8 SPI_ReadByte(void)			//ȡһֽ
	{
		SPDAT = 0XFF;
		while(SPIF == 0);
		SPIF = 1;
		WCOL = 1;		
		return SPDAT;
	}
#else
	void SPI_Init(void)				//ʼ
	{
		P_SW3 &= 0XF3;		//1111 0011		ѡ
		P_SW3 |= 0X04;		//0000 0100
		
		SCON = 0x10;
		
		USARTCR1=0x10;
		USARTCR4=0x00;
		USARTCR1|=0x08;

	}


	void SPI_WriteByte(u8 dat)		//дһֽ
	{
		TI = 0;
		SBUF = dat;
		while(!TI);
	}


	u8 SPI_ReadByte(void)			//ȡһֽ
	{
		TI = 0;
		SBUF = 0X00;
		while(!TI);
		return SBUF;
	}	
#endif

u8 FLASH_CheckID(void)				//ȡID
{
	u8 id;
	CS = 0;
	
	SPI_WriteByte(0XAB);		//дȡid
	
	SPI_WriteByte(0X00);		//д
	SPI_WriteByte(0X00);		//д
	SPI_WriteByte(0X00);		//д
	
	id = SPI_ReadByte();		//ȡ
	
	CS = 1;
	return id;
}


u8 FLASH_CheckBusy(void)		//ȡ״̬
{
	u8 state;
	CS = 0;
	SPI_WriteByte(0X05);		//дȡ״̬
	state = SPI_ReadByte();		//ȡ
	CS = 1;
	return state;
}


void FLASH_WriteEnable(void)	//дʹ
{
	while(FLASH_CheckBusy()>0);
	CS = 0;
	SPI_WriteByte(0X06);		//ддʹ
	CS = 1;
}

void FLASH_Erase(u32 addr)		//
{
	while(FLASH_CheckBusy()>0);
	FLASH_WriteEnable();
	
	CS = 0;
	SPI_WriteByte(0X20);		//д
	
	SPI_WriteByte((u8)(addr>>16));		//дַλ
	SPI_WriteByte((u8)(addr>>8));		//дַ
	SPI_WriteByte((u8)(addr>>0));		//дַλ
	
	CS = 1;
}


void FLASH_Read(u32 addr,u8 *buffr,u16 length)		//dȡ
{
	u16 i=0;
	while(FLASH_CheckBusy()>0);
	
	CS = 0;
	SPI_WriteByte(0X03);		//д
	
	SPI_WriteByte((u8)(addr>>16));		//дַλ
	SPI_WriteByte((u8)(addr>>8));		//дַ
	SPI_WriteByte((u8)(addr>>0));		//дַλ
	
	do
	{
		buffr[i] = SPI_ReadByte();
		i++;
	}while(length--);
	
	CS = 1;
}

void FLASH_Write(u32 addr,u8 *buffr,u16 length)		//dд
{
	u16 i=0;
	if( length==0 )
		return ;
	while(FLASH_CheckBusy()>0);
	FLASH_WriteEnable();
	
	CS = 0;
	SPI_WriteByte(0X02);		//д
	
	SPI_WriteByte((u8)(addr>>16));		//дַλ
	SPI_WriteByte((u8)(addr>>8));		//дַ
	SPI_WriteByte((u8)(addr>>0));		//дַλ
	
	do
	{
		SPI_WriteByte(buffr[i]);
		i++;
		if( addr&0xff==0 )
			break;
	}while(length--);
	CS = 1;
}


